'use strict';

var Je = require('process');
var It = require('crypto');
var Ge = require('fs');
var path = require('path');
var promises = require('fs/promises');
var buffer = require('buffer');
var _i = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Je__default = /*#__PURE__*/_interopDefault(Je);
var It__default = /*#__PURE__*/_interopDefault(It);
var Ge__default = /*#__PURE__*/_interopDefault(Ge);
var _i__default = /*#__PURE__*/_interopDefault(_i);

function Dr(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function J(){let e=Dr();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}var se=-1,he=0,ae=1,Z=2,K=3,Ke=4,Ye=9007199254740991,Gt={"*":-1,a:-1,all:-1,d:0,dbg:0,debug:0,i:1,inf:1,info:1,w:2,warn:2,warning:2,e:3,err:3,error:3,fatal:4,off:9007199254740991,"-":9007199254740991};function Pr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function Fr(){return Pr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function B(e=Fr()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function Sr(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Qe(e){if(e===!1)return 9007199254740991;if(typeof e=="number")return e;if(typeof e=="string"){let t=Gt[e.toLocaleLowerCase().trim()];if(t!=null)return t}return -1}function N(e=Sr()){let t=Qe(e);return n=>n>=t}function xe(e={}){let{level:t=void 0,filter:n=void 0}=e,r=B(n),o=N(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case 1:console.info(`I|*   ${a}`,...i.messages);break;case 2:console.warn(`W|**  ${a}`,...i.messages);break;case 3:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}function zt(e=""){let t=[xe()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let f=Qe(c??-1);function l(g,m){return f<=g?m:()=>{}}let p=l(0,(...g)=>{d({name:u,messages:g,level:0});});p.label=u,p.extend=function(g){return o(u?`${u}:${g}`:g)};let d=g=>{if(n(u))for(let m of t)m&&m(g);};return p.debug=l(0,(...g)=>{d({name:u,messages:g,level:0});}),p.info=l(1,(...g)=>{d({name:u,messages:g,level:1});}),p.warn=l(2,(...g)=>{d({name:u,messages:g,level:2});}),p.error=l(3,(...g)=>{d({name:u,messages:g,level:3});}),p.fatal=l(4,(...g)=>{throw d({name:u,messages:g,level:4}),new Error(`${g.map(String).join(" ")}`)}),p.assert=l(4,(g,...m)=>{(g==null||typeof g=="number"&&Number.isNaN(g)||!g)&&p.fatal(...m);}),p}function s(u="",c){let f=o(u,c);return i&&f.debug(`+++ init of logger "${u}" on level "${f.level}".`),f}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=B(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=-1,s.setLogLevel=function(u=-1){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var O;function Xe(e){let t=zt();return e?e(t):t.setHandlers([xe()]),t}function et(e){if(O==null)try{let t=J();t!=null?t?.logger==null?(O=Xe(e),t.logger=O):O=t.logger:O=Xe(e);}catch{O=Xe(e);}return O}function Wt(){if(O!=null)return O;try{let e=J();if(e?.logger!=null)return e.logger}catch{}}function R(e,t){return et()(e,t)}function Rr(...e){throw Wt()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function Ir(e,...t){(e==null||typeof e=="number"&&Number.isNaN(e)||!e)&&Rr(...t);}function qt(e,...t){Ir(e,...t);}var Mr=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function ss(e,t=void 0){return JSON.stringify(e,Mr,t)}function kr(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,Number.POSITIVE_INFINITY,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function I(e,t,n,r){return JSON.stringify(e,kr(t??void 0,r),n??void 0)}var as=I;function Br(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function $r(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var be;function Jt(e){if(be==null&&(be=Br,typeof TextEncoder<"u")){let t=new TextEncoder;be=n=>t.encode(n);}return be(e.normalize("NFC"))}var Te;function Zt(e){if(Te==null&&(Te=$r,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});Te=n=>t.decode(n);}return Te(e).normalize("NFC")}function C(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?Jt(e):e.length?new Uint8Array(e):e}function ls(...e){let t=0,n=e.flat(1).map(i=>{let a=C(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function Kt(e){if(typeof Buffer<"u")return Buffer.from(C(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...C(e)])n+=t[r>>4]+t[r&15];return n}function Yt(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>Number.parseInt(t,16)))}function ue(e,t=!1){let n=C(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function fs(e){let t=C(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function we(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function ps(e){return Zt(we(e))}function Qt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=C(e),r=C(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function tt(e){return Jt(I(e))}function nt(e){return JSON.parse(Zt(e))}function Xt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let f=c.charCodeAt(0);return ` ${r[(240&f)>>4]}${r[15&f]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20\x7F-\xA0\xAD]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}function ce(e,t,n){return new Uint8Array(e,t,n)}var Y;function tn(){return Y===void 0&&(Y=(typeof TextDecoder>"u"?null:new TextDecoder("utf-8",{fatal:!0,ignoreBOM:!0}))??null,Y&&Y.decode(new Uint8Array).length===1&&(Y=null)),Y}var rt=class{constructor(){this.cpos=0,this.cbuf=new Uint8Array(100),this.bufs=[];}};function Ee(){return new rt}function ot(e){let t=e.cpos;for(let n=0;n<e.bufs.length;n++)t+=e.bufs[n].length;return t}function Ue(e){let t=new Uint8Array(ot(e)),n=0;for(let r=0;r<e.bufs.length;r++){let o=e.bufs[r];t.set(o,n),n+=o.length;}return t.set(ce(e.cbuf.buffer,0,e.cpos),n),t}function Nr(e,t){let n=e.cbuf.length;n-e.cpos<t&&(e.bufs.push(ce(e.cbuf.buffer,0,e.cpos)),e.cbuf=new Uint8Array(Math.max(n,t)*2),e.cpos=0);}function U(e,t){let n=e.cbuf.length;e.cpos===n&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(n*2),e.cpos=0),e.cbuf[e.cpos++]=t;}var sn=U;function an(e,t){U(e,t&255),U(e,t>>>8&255);}function un(e,t){for(let n=0;n<4;n++)U(e,t&255),t>>>=8;}function V(e,t){for(;t>127;)U(e,128|127&t),t=Math.floor(t/128);U(e,127&t);}function jr(e){return e!==0?e<0:1/e<0}function it(e,t){let n=jr(t);for(n&&(t=-t),U(e,(t>63?128:0)|(n?64:0)|63&t),t=Math.floor(t/64);t>0;)U(e,(t>127?128:0)|127&t),t=Math.floor(t/128);}function De(e,t){let n=e.cbuf.length,r=e.cpos,o=Math.min(n-r,t.length),i=t.length-o;e.cbuf.set(t.subarray(0,o),r),e.cpos+=o,i>0&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(Math.max(n*2,i)),e.cbuf.set(t.subarray(o)),e.cpos=i);}function Pe(e,t){V(e,t.byteLength),De(e,t);}function Hr(e,t){let n=unescape(encodeURIComponent(t)),r=n.length;V(e,r);for(let o=0;o<r;o++)U(e,n.codePointAt(o));}function Ce(e,t){return Hr(e,t)}function st(e,t){Nr(e,t);let n=new DataView(e.cbuf.buffer,e.cpos,t);return e.cpos+=t,n}function at(e,t){return st(e,4).setFloat32(0,t,!1)}function Gr(e,t){return st(e,8).setFloat64(0,t,!1)}function zr(e,t){return st(e,8).setBigInt64(0,t,!1)}var Ae;function Wr(e){return Ae==null&&(Ae=new DataView(new ArrayBuffer(4))),Ae.setFloat32(0,e),Ae.getFloat32(0)===e}function X(e,t){switch(typeof t){case"string":U(e,119),Ce(e,t);break;case"number":Number.isInteger(t)&&Math.abs(t)<=2147483647?(U(e,125),it(e,t)):Wr(t)?(U(e,124),at(e,t)):(U(e,123),Gr(e,t));break;case"bigint":U(e,122),zr(e,t);break;case"object":if(t===null)U(e,126);else if(Array.isArray(t)){U(e,117),V(e,t.length);for(let n=0;n<t.length;n++)X(e,t[n]);}else if(t instanceof Uint8Array)U(e,116),Pe(e,t);else {U(e,118);let n=Object.keys(t);V(e,n.length);for(let r=0;r<n.length;r++){let o=n[r];Ce(e,o),X(e,t[o]);}}break;case"boolean":U(e,t?120:121);break;default:U(e,127);}}var cn="Unexpected end of array",ln="Integer out of Range",ut=class{constructor(t){this.arr=t,this.pos=0;}};function Se(e){return new ut(e)}function ct(e,t){let n=ce(e.arr.buffer,e.pos+e.arr.byteOffset,t);return e.pos+=t,n}function ee(e){let t=0,n=1,r=e.arr.length;for(;e.pos<r;){let o=e.arr[e.pos++];if(t=t+(o&127)*n,n*=128,o<128)return t;if(t>Number.MAX_SAFE_INTEGER)throw new Error(ln)}throw new Error(cn)}function Re(e){return ct(e,ee(e))}function pe(e){return e.arr[e.pos++]}function fn(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8);return e.pos+=2,t}function pn(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8)+(e.arr[e.pos+2]<<16)+(e.arr[e.pos+3]<<24)>>>0;return e.pos+=4,t}function lt(e){let t=e.arr[e.pos++],n=t&63,r=64,o=(t&64)>0?-1:1;if(!(t&128))return o*n;let i=e.arr.length;for(;e.pos<i;){if(t=e.arr[e.pos++],n=n+(t&127)*r,r*=128,t<128)return o*n;if(n>Number.MAX_SAFE_INTEGER)throw new Error(ln)}throw new Error(cn)}function qr(e){let t=ee(e);if(t===0)return "";{let n=String.fromCodePoint(pe(e));if(--t<100)for(;t--;)n+=String.fromCodePoint(pe(e));else for(;t>0;){let r=t<1e4?t:1e4,o=e.arr.subarray(e.pos,e.pos+r);e.pos+=r,n+=String.fromCodePoint.apply(null,o),t-=r;}return decodeURIComponent(escape(n))}}function Fe(e){let t=tn();return t?t.decode(Re(e)):qr(e)}function ft(e,t){let n=new DataView(e.arr.buffer,e.arr.byteOffset+e.pos,t);return e.pos+=t,n}function pt(e){return ft(e,4).getFloat32(0,!1)}function Jr(e){return ft(e,8).getFloat64(0,!1)}function Zr(e){return ft(e,8).getBigInt64(0,!1)}var Kr=[e=>{},e=>null,lt,pt,Jr,Zr,e=>!1,e=>!0,Fe,e=>{let t=ee(e),n={};for(let r=0;r<t;r++){let o=Fe(e);n[o]=te(e);}return n},e=>{let t=ee(e),n=[];for(let r=0;r<t;r++)n.push(te(e));return n},Re];function te(e){return Kr[127-pe(e)](e)}var dn=class{async encode(t){let n=Ee();return X(n,t),Ue(n)}async decode(t){return te(Se(C(t)))}};function Ps(e){let t=Ee();return X(t,e),Ue(t)}function Fs(e){return te(Se(C(e)))}function Ss(e){let t=Ee();return e!=null&&De(t,C(e)),{writeBytes:(n,r)=>{let o=C(n);qt(!(r!=null&&o.length!==r),`Expected ${r} bytes, got ${o.length}`),De(t,o);},writeBytesVar:n=>Pe(t,C(n)),writeUintVar:n=>V(t,n),writeUint8:n=>sn(t,n),writeUint16:n=>an(t,n),writeUint32:n=>un(t,n),writeIntVar:n=>it(t,n),writeFloat:n=>at(t,n),writeStringVar:n=>Ce(t,n),write:n=>X(t,n),getUint8Array:()=>Ue(t),getLength:()=>ot(t)}}function Rs(e){let t=Se(C(e));return {readBytes:n=>ct(t,n),readBytesVar:()=>Re(t),readUintVar:()=>ee(t),readUint8:()=>pe(t),readUint16:()=>fn(t),readUint32:()=>pn(t),readIntVar:()=>lt(t),readFloat:()=>pt(t),readStringVar:()=>Fe(t),read:()=>te(t),getOffset:()=>t.pos||0}}function Is(e=0){return {setBit:(t,n=!0)=>n?e|=1<<t:e&=~(1<<t),unsetBit:t=>e&=1<<t,toggleBit:t=>e^=1<<t,getBit:t=>(e&1<<t)!==0,getValue:()=>e}}async function Yr(e){return await e.arrayBuffer()}async function Ms(e){let t=await Yr(e);if(t!=null)return C(t)}function ne(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var mn="SHA-256",dt="AES-GCM",gn="PBKDF2",Qr=1e5;async function $s(e,t=mn){return C(await crypto.subtle.digest(t,C(e)))}async function Os(e,t={}){let n=C(e),r=await crypto.subtle.importKey("raw",n,gn,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:gn,salt:t.salt?C(t.salt):new Uint8Array(0),iterations:t.iterations??Qr,hash:mn},r,{name:dt,length:256},!0,["encrypt","decrypt"])}function yn(){return new Uint8Array([1,1])}async function hn(e,t){let n=yn(),r=ne(12),o=await crypto.subtle.encrypt({name:dt,iv:r},t,e),i=new Uint8Array(o),a=n.length+r.length+i.length,s=new Uint8Array(a),u=0;return s.set(n,u),u+=n.length,s.set(r,u),u+=r.length,s.set(i,u),s}async function xn(e,t){let n=e.subarray(0,2);if(!Qt(n,yn()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:dt,iv:r},t,o);return new Uint8Array(i)}function Xr(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function P(){return typeof crypto<"u"?Xr():Math.random()}function Ns(e=.25){return P()<e}function js(e=100,t=0){return t+Math.floor(P()*(e-t))}function Vs(e=100,t=0){return t+P()*(e-t)}function Hs(e,t,n){return Math.max(e,Math.min(n,t))}function eo(e){return e.reduce((t,n)=>t+n,0)}function Gs(e){return eo(e)/e.length}function zs(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function Ws(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var gt=6;function qs(e=0,t=1,n){gt=((n??gt)*9301+49297)%233280;let r=gt/233280;return t+r*(e-t)}function to(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function Zs(e,t=!0){return `${e} ${t?"asc":"desc"}`}function mt(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Ks(e,...t){if(t.length>0){let n=t.map(to),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=mt(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function yt(e){return e.filter((t,n)=>e.indexOf(t)===n)}function no(e,t){return yt(e.filter(n=>!t.includes(n)))}function ro(...e){return yt(e.reduce((t=[],n)=>t.concat(n),[]))}function re(...e){return e.flat(Number.POSITIVE_INFINITY)}function oo(e,t){return yt(e).filter(n=>t.includes(n))}function ea(e,t){return no(ro(e,t),oo(e,t))}function bn(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function ta(e,t){return e.includes(t)||e.push(t),e}function ht(e,t){return e.splice(0,e.length,...e.filter(t)),e}function na(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function ra(e){return e.splice(0,e.length),e}function io(e,t=mt){return Array.from(e).sort(t)}function oa(e){return io(e,(t,n)=>t-n)}function so(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function Tn(e){return e.sort(()=>P()>.5?1:-1),e}function ia(e){return Tn(Array.from(e))}function sa(e){for(;e.length>1;){let t=Array.from(e);if(Tn(t),!so(e,t))return t}return e}function aa(e){return e[Math.floor(P()*e.length)]}function ua(...e){return re(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function ca(...e){return re(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function la(...e){return re(e).reduce((t,n)=>t+n,0)}function fa(...e){let t=re(e);return t.reduce((n,r)=>n+r,0)/t.length}function pa(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function da(e=0,t){if(e<=0)return [];let n=Array.from({length:e});for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var ao={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function uo(e){let t=ao[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let f=t.charAt(c),l=f.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${f} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,f=-1){let l=C(c);if(l.byteLength===0)return "";let p=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let m=(g-d)*a+1>>>0,b=new Uint8Array(m);for(;d!==g;){let v=l[d],E=0;for(let h=m-1;(v!==0||E<p)&&h!==-1;h--,E++)v+=256*b[h]>>>0,b[h]=v%r>>>0,v=v/r>>>0;if(v!==0)throw new Error("Non-zero carry");p=E,d++;}let y=m-p;for(;y!==m&&b[y]===0;)y++;let w="";for(;y<m;++y)w+=t.charAt(b[y]);return f>0?w.padStart(f,o):w}function u(c,f=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,p=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let w=d-1;(b!==0||y<p)&&w!==-1;w--,y++)b+=r*g[w]>>>0,g[w]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");p=y,l++;}let m=d-p;for(;m!==d&&g[m]===0;)m++;return f>0?new Uint8Array([...new Uint8Array(f-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var Ie;function j(e){Ie==null&&(Ie=new Map);function t(){let o=Ie.get(e);return o==null&&(o=uo(e),Ie.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function xt(e,t=-1){return j(32).encode(e,t)}function wn(e,t=-1){return j(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function ya(e,t=-1){return j(16).encode(e,t)}function ha(e,t=-1){return j(16).decode(e,t)}function xa(e,t=-1){return j(58).encode(e,t)}function ba(e,t=-1){return j(58).decode(e,t)}function bt(e,t=-1){return j(62).encode(e,t)}function Ln(e,t=-1){return j(62).decode(e,t)}function Ta(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}function vn(e){return e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e}function co(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function La(e){return e.replace(/\w\S*/g,co)}function va(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var An=["1","true","yes","y","on"];function Ea(e,t=!1){return e==null||typeof e!="string"?t:An.includes(String(e).trim().toLowerCase())}function Ua(e,t=0){return e==null||typeof e!="string"?t:Number.parseInt(e.trim(),10)??t}function Da(e,t=0){return e==null||typeof e!="string"?t:Number.parseFloat(e.trim())??t}function H(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:An.includes(String(e).trim().toLowerCase())}function lo(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):Number.parseInt(String(e).trim(),10)??t}function fo(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):Number.parseFloat(String(e).trim())??t}function Tt(e,t=""){return e==null?t:String(e)??t}var Pa=fo,Fa=lo,Sa=Tt,Ra=H;function po(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${Xt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function Me(e,t={}){return po(e,t).join(" ")}function Ia(e){try{return decodeURIComponent(escape(e))}catch{}return e}function Ba(e){if(e.startsWith("data:"))return we(e.split(",",2)[1])}function $a(e){if(e.startsWith("data:"))return e.slice(5).split(",",2)[0]}function Oa(e){if(e.startsWith("data:")){let[t,n]=e.slice(5).split(",",2);return new Blob([we(n)],{type:t})}}async function _a(e){let t=await e.arrayBuffer();if(t)return `data:${e.type},${ue(t)}`}function Na(e,t="application/octet-stream"){return `data:${t},${ue(e)}`}var Cn=864e5;function Lt(e){return Math.floor(e/1e4)}function En(e){return Math.floor(e/100%100)}function go(e){return Math.floor(e%100)}function Va(e){return [Lt(e),En(e),go(e)]}function Un(e,t=!1){return t?new Date(`${yo(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Dn(){return Be(new Date)}function Ha(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return Pn(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return vt(n,r,o)}else if(e instanceof Date)return Be(e,t)}function Ga(e){return Un(e,!0)}function Be(e,t=!1){return t?Pn(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function za(e){return Be(e,!0)}function wt(e,t=!0){return Un(e,t).getTime()}function mo(e,t=!0){return Be(new Date(e),t)}function yo(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function vt(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function Pn(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function Wa(e,t=0){let n=Lt(e),r=En(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),vt(n,r,1)}function qa(e,t=0){let n=Lt(e);return vt(n+t,1,1)}function ke(e,t){return mo(wt(e)+t*864e5)}function Ja(e,t){return Math.round((wt(t)-wt(e))/864e5)}function Za(e,t){let n=[];for(t==null&&(t=Dn()),e<0&&(e=ke(t,e+1));e<=t;)n.push(e),e=ke(e,1);return n}function*Ka(e,t){let n=[];for(t==null&&(t=Dn()),e<0&&(e=ke(t,e+1));e<=t;)yield e,e=ke(e,1);return n}function Fn(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Qa(e){return new Promise(t=>setTimeout(t,e))}async function Xa(){return new Promise(e=>setTimeout(e,0))}async function eu(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}function tu(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function Sn(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function nu(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function F(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function G(e){return Promise.resolve(e)}var z=class e{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=e.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new e(t)}static fromString(t){return e.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?e.fromString(t.toISOString().substr(0,10)):e.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return e.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new e(t);if(typeof t=="string")return e.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new e(r*1e4+o*100+i)}else {if(t instanceof Date)return e.fromDate(t,n);if(t instanceof e)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return e.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return e.from([this.year,this.month,1])}yearStart(){return e.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return e.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new e(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function iu(e,t,n){let r=z.from(e),o=z.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);F(i)&&await i,r=r.dayOffset(1);}}function su(){return new z}function au(e){return new z(e)}function uu(e){return z.fromDate(new Date(e)).days}function ho(e,t=2){return +(+e).toFixed(t)}function lu(e,t=2){return +(+e/10**t).toFixed(t)}function fu(e,t=2){return Math.round(+e*10**t)}function pu(e,t=2){return t*(ho(e,t)%1)}function mu(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function yu(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function Rn(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function hu(e){return e!=null&&e.length>0?e[0]:void 0}function xu(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function bu(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function oe(e){return Object(e)!==e?e:JSON.parse(I(e))}function Tu(e){return Object(e)!==e?e:JSON.parse(I(e))}function wu(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function Lu(e){let t=new Map;return async(...n)=>{let r=I(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function vu(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}function $(e){return e!=null&&typeof e=="object"}function At(e){return Object(e)!==e}function _(e){return Array.isArray(e)}function $e(e){return $(e)&&!_(e)}function Eu(e){return e?.constructor===Object}function In(e){return typeof e=="string"}function Mn(e){return typeof e=="number"&&!Number.isNaN(e)}function Uu(e){return Mn(e)&&Number.isInteger(e)}function Du(e){return Mn(e)&&Number.isSafeInteger(e)}function kn(e){return typeof e=="boolean"}function Pu(e){return e==null}function Fu(e){return e==null}function Su(e){return $(e)&&e.constructor.name==="Uint8Array"}function Bn(e){return e!=null}function xo(e){return e==null||e===""||$(e)&&Rn(e)<=0}function Ru(e){return !xo(e)}function Iu(e){return e!=null&&e!==!1&&e!==!0}function Mu(e){return e!=null&&e!==!1&&e!==0&&e!==""}function bo(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(At(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!bo(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function To(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(At(e)||t.add(e),$e(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}To(e[n],t);}}else if(_(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function Oe(e,...t){for(let n of t)$(e)||(e={}),!(n==null||!$(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):$(o)&&$(i)?e[r]=Oe(Object.assign({},o),i):e[r]=i;});return e}function wo(e,t,n={cyclesFix:!0},r=[]){let o=[],i=Array.isArray(e);for(let s in e){let u=e[s],c=i?+s:s;if(!(s in t)){o.push({type:"del",path:[c]});continue}let f=t[s],l=typeof u=="object"&&typeof f=="object";if(u&&f&&l&&!["Date","RegExp","String","Number"].includes(Object.getPrototypeOf(u).constructor.name)&&(!n.cyclesFix||!r.includes(u))){let p=wo(u,f,n,n.cyclesFix?r.concat([u]):[]);o=[...o,...p.map(d=>(d.path.unshift(c),d))];}else u!==f&&!(l&&(Number.isNaN(u)?`${u}`==`${f}`:+u==+f))&&o.push({path:[c],type:"upd",value:f});}let a=Array.isArray(t);for(let s in t)s in e||o.push({type:"new",path:[a?+s:s],value:t[s]});return o}function $n(e){return e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;")}function _u(e){return e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&")}function ju(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Vu(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Hu(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function Gu(e,t){return e.map(n=>n[t])}function qu(e,t){return $(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return _(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function Ju(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function Zu(e){return Object.keys(e).length<=0}var Lo=/[\\\-\[\]\/{}()*+?.^$|]/g;function _e(e){return e?e instanceof RegExp?e.source:e.replace(Lo,"\\$&"):""}var vo=100,Ao=/^\.+/,Co=/\.+$/,Eo=/[<>:\"/\\|?*\u0000-\u001F\u0080-\u009F]+/gm;function On(){return Eo}function Uo(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function _n(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(On().test(t))throw new Error("Replacement string cannot contain reserved filename characters");let n=`(${_e(t)})+`;return e=e.replace(On(),t).replace(Ao,t).replace(Co,"").replace(new RegExp(n,"gm"),t).trim(),e=Uo().test(e)?e+t:e,e.slice(0,vo)}function de(e){return Math.abs(e)%1===.5}function Nn(e){return e%2===0}var ec=e=>Math.ceil(e),tc=e=>Math.floor(e),nc=e=>Math.round(e),rc=e=>{let t=Math.round(e);return de(e)&&Nn(t)?t-1:t},oc=e=>de(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),ic=e=>de(e)?Math.floor(e):Math.round(e),sc=e=>{let t=Math.round(e);return de(e)?Nn(t)?t:t-1:t},ac=e=>de(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function jn(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-P()}function Vn(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+P()}function lc(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return Vn(n);if(e<=0)return jn(n);n=Do([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?jn(n):Vn(n);let c=a+u/2,f=u*.01*(P()-.5);return c+f}function Do(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function dc(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-P()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+P()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,f=s+c/2,l=c*.01*(P()-.5);return f+l}function a(s,u,c){let f=c.length,l=s<u;if(f<=0||s>=f-1)return o(c);if(s<=0)return r(c);c=n([...c]);let p=l?-1:0,d=t(c[s+p])||0,m=(t(c[s+p+1])||0)-d;if(m===0)return l?r(c):o(c);let b=d+m/2,y=m*.01*(P()-.5);return b+y}return {start:r,end:o,between:i,move:a,items:n}}var Po=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function yc(e){return e.split(Po).map((t,n)=>{let r=$n(t);return n%2?`<a target="_blank" href="${r}">${Fo(r)}</a>`:r}).join("")}function Fo(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function Hn(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function hc(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}var So=/\\\s|\s+|#[^\n]*\n?/gm,Ro=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,Gn=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Io(e){return typeof e=="string"?e:e.source||""}function bc(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var zn=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(So,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(Ro,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=s),"("):u)),this.names=Object.keys(this.namedGroups);}o=Io(o),Gn.lastIndex=0;let a=Gn.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Mo=",";function Lc(e,t={}){let{separator:n=Mo}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(kn(i))return i?1:0;let a=String(i);return ($e(i)||_(i))&&(a=I(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function ko(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",_e(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function vc(e,t={}){let n=ko(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}function Bo(e){let t;if(typeof e=="function"?t=e():F(e)?t=e:typeof e.dispose=="function"?t=e.dispose():F(e.dispose)?t=e.dispose:typeof e.cleanup=="function"?t=e.cleanup():F(e.cleanup)&&(t=e.cleanup),F(t))return t}function Ne(e){let t=e;t!=null&&(In(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??R("zeed:dispose"),o=[];function i(c){if(c!=null&&o.includes(c)){ht(o,l=>l!==c);let f=Bo(c);if(F(f))return f}}function a(c){if(c!=null)return o.unshift(c),()=>i(c)}function s(c=!1){n&&r.debug(`dispose "${n}": ${o.length} entries`);let f=[];for(;o.length>0;){let l=o[0],p=i(l);if(F(p)){if(c)throw new Error(`Async disposable found: ${l} -> ${p}`);f.push(p);}}if(f.length>0)return Promise.all(f)}function u(){s(!0);}return Object.assign(s,{add:a,remove:i,track:a,untrack:i,dispose:s,disposeSync:u,sync:u,exec:s,getSize(){return o.length},isDisposed(){return o.length<=0}})}function Pc(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(ht(n,s=>s!==a),typeof a=="function"){let s=a();if(F(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(F(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function Rc(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function Ic(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();F(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();F(o)&&await o;}return r}}var M=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=R("zeed:emitter","warn");this.dispose=Ne();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return G(a(...n))}catch(s){this._logEmitter.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await G(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Nc(){let e=J().emitter;return e||(e=new M,J().emitter=e),e}function jc(e,t){let n=Math.round(P()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):e.log.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,f)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u)continue;f(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`));}break}},o();})}function W(){return Date.now()}function Ct(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Hc(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}function Wn(){return typeof performance<"u"?performance.now():Date.now()}function Gc(){let e=Wn();return function(){let t=Wn()-e;return Ct(t)}}var je=16;function Ut(){return ne(je)}function $o(e=Ut()){return bt(e,22)}function Oo(e){return bt(e,22)}function _o(e){return Ln(e,je)}function No(e=Ut()){return xt(e,26)}function jo(e){return xt(e,26)}function Vo(e){return wn(e,je)}var Ho="10000000-1000-4000-8000-100000000000",Go=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():Ho.replace(/[018]/g,e=>(e^ne(1)[0]&15>>e/4).toString(16))};function zo(e){let t=Kt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function Wo(e){return Yt(e.replaceAll("-",""))}var qn=16e11;function qo(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Jn(){let e=W()-qn;return new Uint8Array([...qo(e),...ne(10)])}function Kc(){return Zo(Jn())}function Yc(e){return Jo(Kn(e))}function Jo(e){return new Date(qn+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function Qc(){return new Uint32Array(ne(4))[0]}var Dt={base62:{uuid:$o,uuidDecode:_o,uuidEncode:Oo},base32:{uuid:No,uuidDecode:Vo,uuidEncode:jo},uuidv4:{uuid:Go,uuidDecode:Wo,uuidEncode:zo}},Ve="base62",Zn=!1;function Xc(e,t=!1){Ve=e,Zn=t;}function q(){return Dt[Ve].uuid(Zn?Jn():Ut())}function Kn(e){return Dt[Ve].uuidDecode(e)}function Zo(e){return Dt[Ve].uuidEncode(e)}function el(e){try{return Kn(e).length===je}catch{}return !1}var Et={};function k(e="id"){return Et[e]==null&&(Et[e]=0),`${e}-${Et[e]++}`}var Ko=0;function tl(){return `id-${Ko++}`}var Pt=class extends M{constructor(){super(...arguments);this.id=q();}close(){this.dispose();}},He=class extends Pt{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:q()});}};function il(){let e=new He,t=new He;return e.other=t,t.other=e,[e,t]}var Yn=class{async encode(t){return t}async decode(t){return t}},ie=class{async encode(t){return tt(t)}async decode(t){return nt(t)}},Qn=class{constructor(t){this.key=t;}async encode(t){let n=tt(t);return await hn(n,this.key)}async decode(t){let n=await xn(t,this.key);return nt(n)}};function Xn(e,t,n={}){return new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)})}function ml(e={}){let{name:t=k("hub"),encoder:n=new ie,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=R(t,i),s={},u,c=[],f,l={},p=()=>{clearTimeout(f);},d=async()=>{if(clearTimeout(f),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(w){a.warn("postMessage",w);break}}c.length>0&&r>0&&(f=setTimeout(d,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await d();},m=async y=>{u=y,u.on("connect",d),u.on("message",async w=>{a("onmessage",typeof w);let{name:v,args:E,id:h,result:x,error:L}=await n.decode(w.data);if(v){a(`name ${v} id ${h}`);try{if(s[v]==null)throw new Error(`handler for ${v} was not found`);let A=s[v](...E);F(A)&&(A=await A),a(`result ${A}`),h&&await g({id:h,result:A});}catch(A){let T=A instanceof Error?A:new Error(Tt(A));a.warn("execution error",T.name),await g({id:h,error:{message:T.message,stack:T.stack,name:T.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[A,T]=l[h];if(A&&T)if(delete l[h],L){let D=new Error(L.message);D.stack=L.stack,D.name=L.name,a.warn("reject",D.name),T(D);}else a("resolve",x),A(x);}else o||a.warn("Unhandled message",w);}),await d();},b=async(y,w,v={})=>{let{timeout:E=5e3}=v,h=q();return await g({name:y,args:w,id:h}),Sn(new Promise((x,L)=>l[h]=[x,L]),E)};return e.channel&&m(e.channel),{dispose:p,connect:m,listen(y){Object.assign(s,y);},send(){return Xn(b,{},{options(y){return Xn(b,{...y})}})}}}var Ft=class extends M{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new ie,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??k("pubsub"),this.log=R(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:f}=u;await this.emitSuper(c,...f);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function wl(e){return new Ft(e)}var er=1;var St=e=>e,tr=St;function vl(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=St,deserialize:a=tr}=t,s=new Map;return r(async u=>{let c=a(u),[f,l,p,d]=c;if(f===1||f===2){let g,m;if(d!=null)try{let b=e[d];g=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";f===1&&p&&n(i(m?[4,m,p]:[3,g,p]));}else if(p){let g=s.get(p);g!=null&&(f===4?g.reject(l):g.resolve(l)),s.delete(p);}}),new Proxy({},{get(u,c){let f=(...p)=>{n(i([2,p,null,c]));};if(t.onlyEvents||o.includes(c))return f.asEvent=f,f;let l=(...p)=>new Promise((d,g)=>{let m=er++;s.set(m,{resolve:d,reject:g}),n(i([1,p,m,c]));});return l.asEvent=f,l}})}function Al(e){let{post:t,on:n,serialize:r=St,deserialize:o=tr}=e,i=[],a={},s=new Map;n(async c=>{let f=o(c),[l,p,d,g]=f;if(l===1||l===2){let m,b;if(g!=null)try{let y=a[g];m=await y(...p);}catch(y){b=String(y);}else b="Method implementation missing";l===1&&d&&t(r(b?[4,b,d]:[3,m,d]));}else if(d){let m=s.get(d);m!=null&&(l===4?m.reject(p):m.resolve(p)),s.delete(d);}});function u(){return new Proxy({},{get(c,f){let l=(...d)=>{t(r([2,d,null,f]));};if(e.onlyEvents||i.includes(f))return l.asEvent=l,l;let p=(...d)=>new Promise((g,m)=>{let b=er++;s.set(b,{resolve:g,reject:m}),t(r([1,d,b,f]));});return p.asEvent=l,p}})}return function(c,f=[]){return Object.assign(a,c??{}),i.push(...f),u()}}var ge=class e extends M{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??k("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new e(n);return this.addChild(r),r}removeChild(n){bn(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return Number.isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function kl(e={}){let{maxParallel:t=3,name:n=k("pool"),idConflictResolution:r="memoize"}=e,o=new M,i=Ne();i.add(w);let a=new ge({name:n});a.on("progressCancelled",w);let s=0,u=0,c=0,f=0,l={};async function p(){if(s>0){let[h,x]=Fn();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,d(),a.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:A,state:T}of Object.values(l))h+=L,x+=T==="finished"?L:Math.min(L,A);o.emit("didUpdate",s,u,h,x);}function b(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(A=>A.state==="running"&&A.id!==L.id&&A.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,A=x.done;x.state="running",++c,o.emit("didStart",L);let T=D=>{x&&(x.result=D,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++u,b();};x.task(x).then(D=>{A(D),o.emit("didResolve",L,D),T(D);}).catch(D=>{A(),o.emit("didReject",L,D),T();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function w(){Object.keys(l).forEach(y);}function v(h){return l[h]!=null}function E(h,x={}){let L,A=new Promise(S=>L=S),T=x.id??q();if(l[T]!=null){let S=x.idConflictResolution??r;if(S==="replace")y(T);else if(S==="memoize"||S==="prioritize"){let Ht=l[T];return S==="prioritize"&&(Ht.priority=++f),{id:T,promise:(async()=>{if(Ht.state==="finished")return l[T].result})(),dispose:()=>y(T),cancel:()=>y(T)}}else throw new Error(`Pool task with id=${T} already exists!`)}let D=new ge({name:T,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(D),l[T]={id:T,task:h,priority:++f,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:D,setMax(S){D.setTotalUnits(S),l[T].max=S,m();},setResolved(S){D.setCompletetedUnits(S),l[T].resolved=S,m();},incResolved(S=1){D.incCompletedUnits(S),l[T].resolved+=S,m();}},++s,b(),{id:T,promise:A,dispose:()=>y(T),cancel:()=>y(T)}}return {events:o,cancel:y,cancelAll:w,hasById:v,progress:a,enqueue:E,dispose:i,waitFinishAll:p}}var nr=class extends M{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=k("queue"),logLevel:o}=n;this.name=r,this.log=R(`zeed:queue:${r}`,o??9007199254740991);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=k(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function Vl(e,t={}){let{delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u;function c(){return i?(clearTimeout(i),i=void 0,!0):!1}function f(...l){let p=Date.now(),d=p-a,g=()=>{s=0,a=Date.now(),e.apply(this,l);};if(u=g,d>n||!i){o&&(d>n?g():++s);let m=d>n?n:n-d;c(),a=p,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&u?.();},m);}else ++s;}return f.cancel=c,f.stop=()=>{c()&&u&&u();},f.immediate=async function(...p){c(),a=Date.now(),e.apply(this,p);},f.dispose=()=>f.stop(),f}function Hl(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){let f=[...i];i=void 0,o=!0,await G(e(...f)),o=!1,i!=null&&(a(),r=setTimeout(s,n));}}catch{}}function u(...f){i=[...f],a(),o===!1&&(r=setTimeout(s,n));}async function c(...f){a(),i=[...f],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function Wl(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function ql(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function Jl(e,t,n=!1){let r,o=!1;async function i(a=!1){a&&await G(e()),o||(r=setTimeout(()=>i(!0),t));}return i(n),()=>{r&&(o=!0,clearInterval(r),r=void 0);}}function Zl(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function Yl(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}var rr=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"];function Xl(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return rr[Math.abs(t)%rr.length]}function rf(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=B(n),i=N(t);return a=>{i(a.level)&&o(a.name)&&(a.timestamp=W(),r.push(a));}}var Rt={cache:"no-cache",redirect:"follow",headers:{}};function Yo(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function or(e,t={},n=fetch){try{_(t)&&(t=Oe({},...re(t)));let r=Yo(String(e));r&&(e=r.url,t=Oe({},t,Qo(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=R("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(a){i.error("Exception:",a);}}catch(r){R("zeed:network").error("fetchBasic",r);}}async function cf(e,t={},n=fetch){try{let r=await or(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){R("zeed:network").error("fetchJSON error:",r);}}async function lf(e,t={},n=fetch){try{let r=await or(e,[Rt,{method:"GET"},t],n);if(r)return await r.text()}catch(r){R("zeed:network").error("fetchHTML error:",r);}}function ff(e,t="POST"){return {method:t,...Rt,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:Hn(e)}}function pf(e,t="POST"){return {method:t,...Rt,headers:{"Content-Type":"application/json; charset=utf-8"},body:I(e)}}function Qo(e,t){return {headers:{Authorization:`Basic ${ue(`${e}:${t}`)}`}}}function ir(){if(typeof window<"u")return window}function Xo(){if(typeof navigator<"u")return navigator}function gf(){return ir()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function mf(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Xo(),n=ir();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function ei(){return typeof window<"u"&&globalThis===window}function yf(e){ei()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var sr=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=oe(n);}getItem(t){return oe(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};function Tf(){}function Af(e={}){let{args:t=Je__default.default.argv.slice(1),alias:n={},normalize:r=vn,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((p,d)=>{let[g,m]=d;typeof m=="string"&&(m=[m]);for(let b of m)p[r(b)]=r(g);return p},{}),u={_:[]};function c(p,d){u[p]==null||typeof u[p]=="boolean"?u[p]=d:Array.isArray(u[p])?u[p].push(d):u[p]=[u[p],d];}let f=[...t],l;for(;l=f.shift();){let p;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=d.split("=",2);d=g.trim(),p=m.trim();}d=r(d),d=s[d]??d,o.includes(d)?c(d,!0):(p=p??f.shift()??"",a.includes(d)&&(p=Number(p??0)),i.includes(d)?Array.isArray(u[d])?u[d].push(p):u[d]=[p]:c(d,p));}else u._.push(l);}return u}function Ef(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function Pf(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&It__default.default&&It__default.default.webcrypto&&(globalThis.crypto=It__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function Ff(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var ri=`
`,oi=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,ii=/\\n/g,si=/\n|\r|\r\n/;function ar(e,t={}){let n={};return String(e).split(si).forEach((r,o)=>{let i=r.match(oi);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(ii,ri))):s=s.trim(),n[a]=s;}}),n}function ai(e,t="."){return path.resolve(Je__default.default.cwd(),e??t)}function ui(e,t=""){return e==null&&(e=t),ai(String(e).trim(),t)}var kt=ui;function kf(e,t=Je__default.default.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function Bf(e={}){let t=e?.path??kt(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=Ge__default.default.existsSync(t)?ar(Ge__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=Ge__default.default.existsSync(`${t}.local`)?ar(Ge__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??Je__default.default.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)||c!=null&&(s[u]=c);}),{parsed:a}}catch(o){return {error:o}}}function jf(e){let t=path.normalize(e),n=Je__default.default.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function $t(e){try{await promises.stat(e);}catch{return !1}return !0}function ze(e){return e.startsWith(".")||e.includes("/.")}async function Vf(...e){let t=path.join(...e);return await $t(t)||await promises.mkdir(t,{recursive:!0}),t}async function Hf(...e){let t=path.join(...e);return await $t(t)&&await promises.rm(t,{recursive:!0}),t}async function Gf(...e){let t=path.join(...e);if(await $t(t))return await promises.readFile(t,"utf-8")}async function zf(e,t){await promises.writeFile(e,t,"utf-8");}function We(e,t){if(typeof e!="string")throw new TypeError("Expected a string");let n=String(e),r="",o=t?!!t.extended:!1,i=t?!!t.globstar:!1,a=!1,s=t&&typeof t.flags=="string"?t.flags:"",u;for(let c=0,f=n.length;c<f;c++)switch(u=n[c],u){case"/":case"$":case"^":case"+":case".":case"(":case")":case"=":case"!":case"|":r+=`\\${u}`;break;case"?":o&&(r+=".");break;case"[":case"]":o&&(r+=u);break;case"{":o&&(a=!0,r+="(");break;case"}":o&&(a=!1,r+=")");break;case",":a?r+="|":r+=`\\${u}`;break;case"*":{let l=n[c-1],p=1;for(;n[c+1]==="*";)p++,c++;let d=n[c+1];i?p>1&&(l==="/"||l===void 0)&&(d==="/"||d===void 0)?(r+="((?:[^/]*(?:/|$))*)",c++):r+="([^/]*)":r+=".*";}break;default:r+=u;}return (!s||!~s.indexOf("g"))&&(r=`^${r}$`),new RegExp(r,s)}function cr(e){try{return Ge.statSync(e)}catch{}}function Xf(e){let{mtimeMs:t,size:n}=cr(e)??{};return `${e}|${t}|${n}`}function lr(e,t="",n=!0){let r=[],o=Ge.readdirSync(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&ze(i))continue;let a=path.join(e,i),s=cr(a);s&&s.isDirectory()?r=r.concat(lr(e,i)||[]):r.push(i);}return r}function ep(e={}){let{pattern:t,filter:n,basePath:r=Je__default.default.cwd(),ignoreHidden:o=!1}=e,i=lr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=We(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}async function pr(e){try{return await promises.stat(e)}catch{}}async function ap(e){let{mtimeMs:t,size:n}=await pr(e)??{};return `${e}|${t}|${n}`}async function dr(e,t="",n=!0){let r=[],o=await promises.readdir(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&ze(i))continue;let a=path.join(e,i),s=await pr(a);s&&s.isDirectory()?r=r.concat(await dr(e,i)||[]):r.push(i);}return r}async function up(e={}){let{pattern:t,filter:n,basePath:r=Je__default.default.cwd(),ignoreHidden:o=!1}=e,i=await dr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=We(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}var yr=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(Je__default.default.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?I(n,null,2):I(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??_n;}setItem(t,n){this.store[t]=oe(n);try{let r=this.objectToString(n),o=this.getPath(t);Ge.mkdirSync(path.dirname(o),{recursive:!0}),Ge.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return buffer.Buffer.from(Ge.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return oe(n);try{let r=this.getPath(t),o=Ge.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);Ge.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},Ge.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=Ge.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};var hr={};function xr(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(Je__default.default.cwd(),e),Ge.mkdirSync(path.dirname(e),{recursive:!0});let a=Ge.createWriteStream(e,{flags:"a"}),s=B(r),u=N(n);return c=>{if(!u(c.level)||!s(c.name))return;let f=o?`${new Date().toISOString()} `:"",l=c.name||"",p=hr[l||""];p==null&&(hr[l]=p);let d=[`[${l||"*"}]`,Me(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case 1:g(`${f}I|*  `,...d);break;case 2:g(`${f}W|** `,...d);break;case 3:g(`${f}E|***`,...d);break;default:g(`${f}D|   `,...d);break}}}function $i(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Bn)??[]}function Tr(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(Je__default.default.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=Je__default.default.env?.HOME?path.resolve(Je__default.default.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Oi(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function _t(e=2,t=!0){let n=new Error("stack").stack||"",r=$i(n)?.[e];return r&&t&&(r=Tr(r)),r||""}function wr(){return new Error("stack").stack||""}function Lr(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=Oi(n)),n&&t&&(n=Tr(n));}return n}function Ni(){try{return H(Je__default.default.env.ZEED_COLOR,_i__default.default.isatty(Je__default.default.stdout.fd))}catch{}return !1}var Nt,vr=[6,2,3,4,5,1];function ji(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return vr[Math.abs(t)%vr.length]}var Ar={},jt;function qe(...e){Je__default.default.stdout.write(`${Me(e)}
`);}var ye={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var Er="\x1B[0m";function me(e,t){return `${t===8?ye.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${Er}`}function Cr(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=Er;return n&&(o=`${ye.BOLD}${o}`,i=`${i}${ye.BOLD}`),`${o}${r}${i}`})}function Vi(){try{return H(Je__default.default.env.ZEED_STACK,!1)}catch{}return !1}var Vt,Hi="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function Ur(e={}){Nt==null&&(Nt=Ni()),Vt==null&&(Vt=Vi()),jt==null&&(jt=W());let{level:t=void 0,filter:n=void 0,colors:r=Nt,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=Vt,time:c=!0}=e,f=B(n),l=N(t);return p=>{if(!l(p.level)||!f(p.name))return;let d=W(),g=p.name||"",m=Ar[g||""];m==null&&(m={color:ji(g)},Ar[g]=m);let b=Ct(d-jt),y,w=i?`[${g}]`:g;if(a>0&&(w=w.padStart(a," ")),s>0&&(w=w.padEnd(s," ")),r){let h=m.color;y=[`${me(w,h)} | `],p.level===2?y.push(...Cr(p.messages,ye.ORANGE)):p.level===3?y.push(...Cr(p.messages,ye.RED)):y.push(...p.messages),c&&y.push(me(`+${b}`,h));}else y=[w,...p.messages],c&&y.push(`+${b}`);if(p.messages?.[0]===Hi&&console.log(wr()),u){let h="";typeof u=="boolean"?(h=Lr(["at Function.","at null.log (","at log ("],!0),h||(h=_t(0,!0))):h=_t(typeof u=="number"?u:3,!0),h&&y.push(me(`(${h})`,7));}let v="|",E=".";switch(p.level){case 1:o&&(y[0]=`I${v}${E}   ${y[0]}`),qe(...y);break;case 2:o&&(y[0]=(r?me(`W${v}${E}${E}  `,8):`W${v}${E}${E}  `)+y[0]),qe(...y);break;case 3:o&&(y[0]=(r?me(`E${v}${E}${E}${E} `,1):`E${v}${E}${E}${E} `)+y[0]),qe(...y);break;default:o&&(y[0]=`D${v}    ${y[0]}`),qe(...y);break}}}function Gi(e,t){return et(n=>{let r=[Ur({padding:32,nameBrackets:!1})],o=Je__default.default.env.ZEED_LOG??Je__default.default.env.LOG,i=H(Je__default.default.env.ZEED_TIME,!0),a=H(Je__default.default.env.ZEED_PRETTY,!1);o&&r.unshift(xr(kt(o),{time:i,pretty:a})),n.setHandlers(r);})(e,t)}

exports.BinaryEncoder = dn;
exports.CRYPTO_DEFAULT_ALG = dt;
exports.CRYPTO_DEFAULT_DERIVE_ALG = gn;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Qr;
exports.CRYPTO_DEFAULT_HASH_ALG = mn;
exports.Channel = Pt;
exports.CryptoEncoder = Qn;
exports.DAY_MS = Cn;
exports.Day = z;
exports.DefaultLogger = R;
exports.Emitter = M;
exports.FileStorage = yr;
exports.JsonEncoder = ie;
exports.LocalChannel = He;
exports.LogLevelAlias = Gt;
exports.LogLevelAll = se;
exports.LogLevelDebug = he;
exports.LogLevelError = K;
exports.LogLevelFatal = Ke;
exports.LogLevelInfo = ae;
exports.LogLevelOff = Ye;
exports.LogLevelWarn = Z;
exports.Logger = Gi;
exports.LoggerConsoleHandler = xe;
exports.LoggerContext = zt;
exports.LoggerFileHandler = xr;
exports.LoggerMemoryHandler = rf;
exports.LoggerNodeHandler = Ur;
exports.MemStorage = sr;
exports.NoopEncoder = Yn;
exports.Progress = ge;
exports.PubSub = Ft;
exports.SerialQueue = nr;
exports.Uint8ArrayToDataUri = Na;
exports.Uint8ArrayToHexDump = Xt;
exports.Uint8ArrayToJson = nt;
exports.Uint8ArrayToString = Zt;
exports.XRX = zn;
exports._decodeUtf8Polyfill = $r;
exports._encodeUtf8Polyfill = Br;
exports._useBase = uo;
exports.arrayAvg = fa;
exports.arrayBatches = pa;
exports.arrayEmptyInPlace = ra;
exports.arrayFilterInPlace = ht;
exports.arrayFlatten = re;
exports.arrayIntersection = oo;
exports.arrayIsEqual = so;
exports.arrayMax = ua;
exports.arrayMin = ca;
exports.arrayMinus = no;
exports.arrayRandomElement = aa;
exports.arrayRemoveElement = bn;
exports.arraySetElement = ta;
exports.arrayShuffle = ia;
exports.arrayShuffleForce = sa;
exports.arrayShuffleInPlace = Tn;
exports.arraySorted = io;
exports.arraySortedNumbers = oa;
exports.arraySum = la;
exports.arraySymmetricDifference = ea;
exports.arrayToggleInPlace = na;
exports.arrayUnion = ro;
exports.arrayUnique = yt;
exports.assert = Ir;
exports.assertCondition = qt;
exports.avg = Gs;
exports.between = Hs;
exports.bitfield = Is;
exports.blobToArrayBuffer = Yr;
exports.blobToDataUri = _a;
exports.blobToUint8Array = Ms;
exports.browserSelectColorByName = Xl;
exports.cloneJsonObject = Tu;
exports.cloneObject = oe;
exports.cmp = mt;
exports.colorString = me;
exports.colorStringList = Cr;
exports.composeOrderby = Zs;
exports.createArray = da;
exports.createBinaryStreamDecoder = Rs;
exports.createBinaryStreamEncoder = Ss;
exports.createLocalChannelPair = il;
exports.createPromise = Fn;
exports.createPromiseProxy = Xn;
exports.csvParse = ko;
exports.csvParseToObjects = vc;
exports.csvStringify = Lc;
exports.dataUriToBlob = Oa;
exports.dataUriToMimeType = $a;
exports.dataUriToUint8Array = Ba;
exports.dateStringToDays = uu;
exports.day = au;
exports.dayDay = go;
exports.dayDiff = Ja;
exports.dayFromAny = Ha;
exports.dayFromDate = Be;
exports.dayFromDateGMT = za;
exports.dayFromParts = vt;
exports.dayFromString = Pn;
exports.dayFromTimestamp = mo;
exports.dayFromToday = Dn;
exports.dayIterator = Ka;
exports.dayMonth = En;
exports.dayMonthStart = Wa;
exports.dayOffset = ke;
exports.dayRange = Za;
exports.dayToDate = Un;
exports.dayToDateGMT = Ga;
exports.dayToParts = Va;
exports.dayToString = yo;
exports.dayToTimestamp = wt;
exports.dayYear = Lt;
exports.dayYearStart = qa;
exports.debounce = Hl;
exports.decimal = ho;
exports.decimalCentsPart = pu;
exports.decimalFromCents = lu;
exports.decimalToCents = fu;
exports.decodeBase16 = ha;
exports.decodeBase32 = wn;
exports.decodeBase58 = ba;
exports.decodeBase62 = Ln;
exports.decodeJson = Fs;
exports.decrypt = xn;
exports.deepEqual = bo;
exports.deepMerge = Oe;
exports.deepStripUndefinedInPlace = To;
exports.deriveKeyPbkdf2 = Os;
exports.detect = mf;
exports.diffObjects = wo;
exports.digest = $s;
exports.duration = Gc;
exports.empty = bu;
exports.encodeBase16 = ya;
exports.encodeBase32 = xt;
exports.encodeBase58 = xa;
exports.encodeBase62 = bt;
exports.encodeJson = Ps;
exports.encodeQuery = Hn;
exports.encrypt = hn;
exports.endSortWeight = Vn;
exports.ensureFolder = Vf;
exports.ensureKey = mu;
exports.ensureKeyAsync = yu;
exports.equalBinary = Qt;
exports.escapeHTML = $n;
exports.escapeRegExp = _e;
exports.estimateSizeForBase = Ta;
exports.exists = $t;
exports.fatal = Rr;
exports.fetchBasic = or;
exports.fetchJson = cf;
exports.fetchOptionsBasicAuth = Qo;
exports.fetchOptionsFormURLEncoded = ff;
exports.fetchOptionsJson = pf;
exports.fetchText = lf;
exports.files = ep;
exports.filesAsync = up;
exports.first = hu;
exports.fixBrokenUth8String = Ia;
exports.forEachDay = iu;
exports.forTimes = vu;
exports.formatMessages = po;
exports.formatMilliseconds = Ct;
exports.fromBase64 = we;
exports.fromBase64String = ps;
exports.fromCamelCase = va;
exports.fromHex = Yt;
exports.getEnvVariableRelaxed = kf;
exports.getFingerprint = Xf;
exports.getFingerprintAsync = ap;
exports.getGlobal = gf;
exports.getGlobalContext = J;
exports.getGlobalEmitter = Nc;
exports.getGlobalLogger = et;
exports.getGlobalLoggerIfExists = Wt;
exports.getNamespaceFilterString = Pr;
exports.getNavigator = Xo;
exports.getPerformanceTimestamp = Wn;
exports.getSecureRandom = Xr;
exports.getSecureRandomIfPossible = P;
exports.getSourceLocation = _t;
exports.getSourceLocationByPrecedingPattern = Lr;
exports.getStack = wr;
exports.getStackLlocationList = $i;
exports.getStat = cr;
exports.getStatAsync = pr;
exports.getTimestamp = W;
exports.getWebCrypto = Ff;
exports.getWindow = ir;
exports.globToRegExp = We;
exports.immediate = Xa;
exports.isArray = _;
exports.isBoolean = kn;
exports.isBrowser = ei;
exports.isEmpty = xo;
exports.isEven = Nn;
exports.isHalf = de;
exports.isHiddenPath = ze;
exports.isInteger = Uu;
exports.isLocalHost = Yl;
exports.isNotEmpty = Ru;
exports.isNotNull = Bn;
exports.isNull = Fu;
exports.isNullOrUndefined = Pu;
exports.isNumber = Mn;
exports.isObject = $;
exports.isPrime = Ws;
exports.isPrimeRX = zs;
exports.isPrimitive = At;
exports.isPromise = F;
exports.isRecord = $e;
exports.isRecordPlain = Eu;
exports.isSafeInteger = Du;
exports.isString = In;
exports.isTimeout = tu;
exports.isTruthy = Mu;
exports.isUint8Array = Su;
exports.isValue = Iu;
exports.joinToUint8Array = ls;
exports.jsonStringify = as;
exports.jsonStringifySafe = I;
exports.jsonStringifySorted = ss;
exports.jsonToUint8Array = tt;
exports.last = xu;
exports.lazyListener = jc;
exports.linkifyPlainText = yc;
exports.listDistinctUnion = Hu;
exports.listGroupBy = Vu;
exports.listOfKey = Gu;
exports.listQuery = ju;
exports.loggerStackTraceDebug = Hi;
exports.memoize = wu;
exports.memoizeAsync = Lu;
exports.moveSortWeight = lc;
exports.noop = Tf;
exports.objectIsEmpty = Zu;
exports.objectMap = qu;
exports.objectMergeDisposable = Ju;
exports.parseArgs = Af;
exports.parseBasicAuth = Yo;
exports.parseDate = Hc;
exports.parseLogLevel = Qe;
exports.parseOrderby = to;
exports.parseQuery = hc;
exports.pbcopy = Ef;
exports.promisify = G;
exports.qid = tl;
exports.randomBoolean = Ns;
exports.randomFloat = Vs;
exports.randomInt = js;
exports.randomUint8Array = ne;
exports.readText = Gf;
exports.regExpEscape = bc;
exports.regExpString = Io;
exports.removeFolder = Hf;
exports.renderMessages = Me;
exports.roundDown = tc;
exports.roundHalfAwayFromZero = oc;
exports.roundHalfDown = ic;
exports.roundHalfEven = sc;
exports.roundHalfOdd = rc;
exports.roundHalfTowardsZero = ac;
exports.roundHalfUp = nc;
exports.roundUp = ec;
exports.seededRandom = qs;
exports.setUuidDefaultEncoding = Xc;
exports.setupEnv = Bf;
exports.setupWebCrypto = Pf;
exports.size = Rn;
exports.sleep = Qa;
exports.sortedItems = Do;
exports.sortedOrderby = Ks;
exports.startSortWeight = jn;
exports.stringToBoolean = Ea;
exports.stringToFloat = Da;
exports.stringToInteger = Ua;
exports.stringToPath = ai;
exports.stringToUInt8Array = Jt;
exports.suid = Kc;
exports.suidBytes = Jn;
exports.suidBytesDate = Jo;
exports.suidDate = Yc;
exports.sum = eo;
exports.throttle = Vl;
exports.timeout = eu;
exports.toBase64 = ue;
exports.toBase64Url = fs;
exports.toBool = Ra;
exports.toCamelCase = vn;
exports.toCapitalize = co;
exports.toCapitalizeWords = La;
exports.toFloat = Pa;
exports.toHex = Kt;
exports.toHumanReadableFilePath = jf;
exports.toHumanReadableUrl = Fo;
exports.toInt = Fa;
exports.toPath = kt;
exports.toString = Sa;
exports.toUint8Array = C;
exports.toValidFilename = _n;
exports.today = su;
exports.tryTimeout = Sn;
exports.uname = k;
exports.unescapeHTML = _u;
exports.useAsyncMutex = Ic;
exports.useBase = j;
exports.useDefer = Pc;
exports.useDispose = Ne;
exports.useEventListener = Zl;
exports.useExitHandler = yf;
exports.useInterval = ql;
exports.useIntervalPause = Jl;
exports.useLevelFilter = N;
exports.useMessageHub = ml;
exports.useMutex = Rc;
exports.useNamespaceFilter = B;
exports.usePool = kl;
exports.usePubSub = wl;
exports.useRPC = vl;
exports.useRPCHub = Al;
exports.useSorted = dc;
exports.useTimeout = Wl;
exports.uuid = q;
exports.uuid32bit = Qc;
exports.uuidB32 = No;
exports.uuidB62 = $o;
exports.uuidBytes = Ut;
exports.uuidDecode = Kn;
exports.uuidDecodeB32 = Vo;
exports.uuidDecodeB62 = _o;
exports.uuidDecodeV4 = Wo;
exports.uuidEncode = Zo;
exports.uuidEncodeB32 = jo;
exports.uuidEncodeB62 = Oo;
exports.uuidEncodeV4 = zo;
exports.uuidIsValid = el;
exports.uuidv4 = Go;
exports.valueToBoolean = H;
exports.valueToFloat = fo;
exports.valueToInteger = lo;
exports.valueToPath = ui;
exports.valueToString = Tt;
exports.waitOn = nu;
exports.walkSync = lr;
exports.walkSyncAsync = dr;
exports.writeText = zf;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map